Skip to content
Back to top
View this page

# `ImageWin` module (Windows-only)

The `ImageWin` module contains support to create and display images on Windows.

ImageWin can be used with PythonWin and other user interface toolkits that provide access to Windows device contexts or window handles. For example, Tkinter makes the window handle available via the winfo_id method:

    from PIL import ImageWin

    dib = ImageWin.Dib(...)

    hwnd = ImageWin.HWND(widget.winfo_id())
    dib.draw(hwnd, xy)

class PIL.ImageWin.Dib(image: Image | str, size: tuple[int, int] | None = None)

  A Windows bitmap with the given mode and size. The mode can be one of “1”, “L”, “P”, or “RGB”.

  If the display requires a palette, this constructor creates a suitable palette and associates it with the image. For an “L” image, 128 graylevels are allocated. For an “RGB” image, a 6x6x6 colour cube is used, together with 20 graylevels.

  To make sure that palettes work properly under Windows, you must call the `palette` method upon certain events from Windows.

  Parameters:

    - image – Either a PIL image, or a mode string. If a mode string is used, a size must also be given. The mode can be one of “1”, “L”, “P”, or “RGB”.

    - size – If the first argument is a mode string, this defines the size of the image.

  draw(handle: int | HDC | HWND, dst: tuple[int, int, int, int], src: tuple[int, int, int, int] | None = None) → None

    Same as expose, but allows you to specify where to draw the image, and what part of it to draw.

    The destination and source areas are given as 4-tuple rectangles. If the source is omitted, the entire image is copied. If the source and the destination have different sizes, the image is resized as necessary.

  expose(handle: int | HDC | HWND) → None

    Copy the bitmap contents to a device context.

    Parameters:

      handle – Device context (HDC), cast to a Python integer, or an HDC or HWND instance. In PythonWin, you can use `CDC.GetHandleAttrib()` to get a suitable handle.

  frombytes(buffer: bytes | memoryview) → None

    Load display memory contents from byte data.

    Parameters:

      buffer – A buffer containing display data (usually data returned from `tobytes()`)

  paste(im: Image, box: tuple[int, int, int, int] | None = None) → None

    Paste a PIL image into the bitmap image.

    Parameters:

      - im – A PIL image. The size must match the target region. If the mode does not match, the image is converted to the mode of the bitmap image.

      - box – A 4-tuple defining the left, upper, right, and lower pixel coordinate. See Coordinate system. If None is given instead of a tuple, all of the image is assumed.

  query_palette(handle: int | HDC | HWND) → int

    Installs the palette associated with the image in the given device context.

    This method should be called upon QUERYNEWPALETTE and PALETTECHANGED events from Windows. If this method returns a non-zero value, one or more display palette entries were changed, and the image should be redrawn.

    Parameters:

      handle – Device context (HDC), cast to a Python integer, or an HDC or HWND instance.

    Returns:

      The number of entries that were changed (if one or more entries, this indicates that the image should be redrawn).

  tobytes() → bytes

    Copy display memory contents to bytes object.

    Returns:

      A bytes object containing display data.

class PIL.ImageWin.HDC(dc: int)

  Wraps an HDC integer. The resulting object can be passed to the `draw()` and `expose()` methods.

class PIL.ImageWin.HWND(wnd: int)

  Wraps an HWND integer. The resulting object can be passed to the `draw()` and `expose()` methods, instead of a DC.